diff --git a/src/skelstruct_strcnt_lua.h b/src/skelstruct_strcnt_lua.h
new file mode 100644
index 0000000..7c4e87a
--- /dev/null
+++ b/src/skelstruct_strcnt_lua.h
@@ -0,0 +1,46 @@
+//
+//
+// C++ Interface: skelstruct_strcnt_lua
+//
+// Description: used for computing the length of the string to be generated for Lua
+//
+//
+// Author: Raman Gopalan <ramangopalan@gmail.com>
+//
+// Copyright: See COPYING file that comes with this distribution
+//
+//
+
+#ifndef SKELSTRUCT_STRCNT_LUA_H
+#define SKELSTRUCT_STRCNT_LUA_H
+
+#include "skelstruct_lua_common.h"
+
+class SkelStructStrCntLua : public SkelStruct_Lua_Common
+{
+ protected:
+  int length;
+  set<string> examined_variables;
+
+ public:
+  // redefined from SkelStruct
+  virtual void call_external_function(ostream &stream, const string &name,
+                                      unsigned int indent);
+  virtual void std_generation(ostream &stream, const string &s);
+  virtual void std_indentstr_generation(ostream &stream, const string &name,
+                                        unsigned int indent);
+  virtual void variable_generation(ostream &stream, const string &name,
+                                   const skelitem_type &t,
+                                   unsigned int indent);
+  virtual void indent_update_generation(ostream &stream, int i);
+  virtual void indent_generation(ostream &stream, const string &ind);
+  virtual string preformat(const string &item) { return item; }
+  virtual void replace_chars(string &) {}
+
+ public:
+  SkelStructStrCntLua (const SkelStruct_Lua_Common &s);
+
+  int compute_length (ostream &stream, int indent);
+};
+
+#endif // SKELSTRUCT_STRCNT_LUA_H
diff --git a/tests/Makefile.am b/tests/Makefile.am
index e45c4f8..d10b487 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -10,14 +10,16 @@
 
 SUBDIRS = otherdir
 
-SUFFIXES = .err .cc_skel .err_test .cc_skel .h .cc_skel _c.h .cc_skel
+SUFFIXES = .err .cc_skel .err_test .cc_skel .h .cc_skel _c.h .cc_skel _lua.lua
 
 PROGEXE = $(top_builddir)/src/$(PACKAGE)$(EXEEXT)
 PROGEXE_C = $(PROGEXE) --output-format "c"
+PROGEXE_LUA = $(PROGEXE) --output-format "lua"
 PROGNAME = $(PROGEXE) --no-gen-version 2>> $(VERBOSEOUT)
 
 GENERATE = $(PROGNAME)
 GENERATE_C = $(PROGNAME) --output-format "c"
+GENERATE_LUA = $(PROGNAME) --output-format "lua"
 GENERATEERR = $(PROGNAME) --test-mode
 
 TEMP_H = __temp.h
@@ -34,12 +36,18 @@ test_cicle_tabs.h: $(srcdir)/test_cicle_tabs.cc_skel
 test_cicle_tabs_c.h: $(srcdir)/test_cicle_tabs.cc_skel
 	$(GENERATE_C) -i $(srcdir)/test_cicle_tabs.cc_skel --file-name $@ --gen-name test_cicle --expand-tabs
 
+test_cicle_tabs_lua.lua: $(srcdir)/test_cicle_tabs.cc_skel
+	$(GENERATE_LUA) -i $(srcdir)/test_cicle_tabs.cc_skel --file-name $@ --gen-name test_cicle --expand-tabs
+
 .cc_skel.h:
 	$(GENERATE) -i $< --file-name $@ --gen-name $* 
 
 .cc_skel_c.h:
 	$(GENERATE_C) -i $< --file-name $@ --gen-name $* 
 
+.cc_skel_lua.lua:
+	$(GENERATE_LUA) -i $< --file-name $@ --gen-name $*
+
 # the cp is useful when building on a different directory
 # since the sources are also deleted during `make check`
 # see also clean-gen-files:
@@ -55,19 +63,19 @@ notbool.err notbool2.err notbool3.err \
 notsametype.err notsametype2.err
 
 EXTRA_DIST = test_vars.cc_skel test_cicle.cc_skel \
-test_cicle_tabs.cc_skel test_body_loop.cc_skel \
+test_cicle_tabs.cc_skel test_body_loop.cc_skel test_body_loop_lua.skel \
 loop.cc_skel test_subst.cc_skel test_subst.cc_skel test_iter.cc_skel \
 test1.cc_skel example_text.text_skel example_fundef.cc_skel \
-test_vars.cc test_cicle.cc test_cicle_str.cc test_cicle2_main.c \
+test_vars.cc test_cicle.cc test_cicle_str.cc test_cicle2_main.c test_cicle2_main.lua \
 test_iter.cc test_cicle_m.cc test_subst.cc \
-test_subst2_main.cc test1_gen.cc test1_gen_c.c \
-example_text_gen.cc example_text_gen_c.c \
+test_subst2_main.cc test1_gen.cc test1_gen_c.c test1_gen.lua \
+example_text_gen.cc example_text_gen_c.c example_text_gen_lua.lua \
 example_fundef_gen.cc \
-test_cicle_c.c test_cicle_str_c.c test_cicle2_c.c \
+test_cicle_c.c test_cicle_gen_lua.lua test_cicle_str_c.c test_cicle2_c.c test_cicle2_lua.lua \
 test_cicle_cstring.c test_cicle_c_cc.cc \
-test_cicle_tabs.cc test_cicle_tabs_c.c \
-test_if.cc_skel test_if.cc test_if_c.c \
-test_types.cc_skel test_types.cc test_types_c.c \
+test_cicle_tabs.cc test_cicle_tabs_c.c test_cicle_tabs_gen_lua.lua \
+test_if.cc_skel test_if.cc test_if_c.c test_if_gen_lua.lua \
+test_types.cc_skel test_types.cc test_types_c.c test_types_gen_lua.lua \
 $(GENERATED_TESTS) \
 $(ERRFILES) \
 $(ERRFILES_OUTPUT) \
@@ -80,18 +88,18 @@ test_cicle$(EXEEXT) test_cicle_str$(EXEEXT) test_cicle_tabs$(EXEEXT) \
 gen_test_cicle$(EXEEXT) gen_test_cicle_str$(EXEEXT) \
 test_cicle_m$(EXEEXT) gen_test_cicle_m$(EXEEXT) test_subst$(EXEEXT) \
 gen_test_subst$(EXEEXT) test_iter$(EXEEXT) \
-gen_test_iter$(EXEEXT) test_subst2_prog$(EXEEXT) test1_gen$(EXEEXT) test1_gen_c$(EXEEXT) \
-example_text_gen$(EXEEXT) example_text_gen_c$(EXEEXT) \
+gen_test_iter$(EXEEXT) test_subst2_prog$(EXEEXT) test1_gen$(EXEEXT) test1_gen_c$(EXEEXT) test1_gen_lua$(EXEEXT) \
+example_text_gen$(EXEEXT) example_text_gen_c$(EXEEXT) example_text_gen_lua$(EXEEXT) \
 example_fundef_gen$(EXEEXT) \
-test_cicle_c$(EXEEXT) test_cicle_str_c$(EXEEXT) \
-test_cicle2_c$(EXEEXT) test_cicle_c_cc$(EXEEXT) \
-test_cicle_tabs_c$(EXEEXT) \
+test_cicle_c$(EXEEXT) test_cicle_gen_lua$(EXEEXT) test_cicle_str_c$(EXEEXT) \
+test_cicle2_c$(EXEEXT) test_cicle2_lua$(EXEEXT) test_cicle_c_cc$(EXEEXT) \
+test_cicle_tabs_c$(EXEEXT) test_cicle_tabs_gen_lua$(EXEEXT) \
 gen_test_cicle_c$(EXEEXT) gen_test_cicle_str_c$(EXEEXT) \
 gen_test_cicle_c_cc$(EXEEXT) \
 test_cicle_cstring$(EXEEXT) gen_test_cicle_cstring$(EXEEXT) \
 gen_test_cicle_tabs$(EXEEXT) \
-test_if$(EXEEXT) test_if_c$(EXEEXT) \
-test_types$(EXEEXT) test_types_c$(EXEEXT)
+test_if$(EXEEXT) test_if_c$(EXEEXT) test_if_gen_lua$(EXEEXT) \
+test_types$(EXEEXT) test_types_c$(EXEEXT) test_types_gen_lua$(EXEEXT)
 
 # we do not want that generated sources are included in the tar ball
 # so we have to do things manually:
@@ -142,15 +150,16 @@ test_body_loop.h gen_test_cicle.cc gen_test_cicle_str.cc \
 loop.h gen_test_cicle_m.cc \
 test_subst.h gen_test_subst.cc test_iter.h gen_test_iter.cc \
 test_subst2.h test_subst2.cc \
-test1.h test1_c.h \
-example_text.h example_text_c.h example_fundef.h \
-test_cicle_c.h test_cicle2_c.h test_cicle2_c.c test_body_loop_c.h \
-test_cicle_tabs_c.h \
+test1.h test1_c.h test1_lua.lua \
+example_text.h example_text_c.h example_text_lua.lua example_fundef.h \
+test_cicle_c.h test_cicle_lua.lua test_cicle2_c.h test_cicle2_lua.header \
+test_cicle2_c.c test_cicle2_lua.lua test_body_loop_c.h test_body_loop_lua.lua \
+test_cicle_tabs_c.h test_cicle_tabs_lua.lua \
 gen_test_cicle_c.cc gen_test_cicle_str_c.cc \
 gen_test_cicle_cstring.cc gen_test_cicle_c_cc.cc \
 gen_test_cicle_tabs.cc gen_test_cicle_tabs_c.cc \
-test_if.h test_if_c.h \
-test_types.h test_types_c.h
+test_if.h test_if_c.h test_if_lua.lua \
+test_types.h test_types_c.h test_types_lua.lua
 
 # there seem to be problems if using *.test in EXTRA_DIST:
 # it works with `make dist` but not with `make distcheck`
@@ -161,29 +170,29 @@ gen_test_cicle_m.cc.test \
 test_subst.h.test gen_test_subst.cc.test test_iter.h.test \
 gen_test_iter.cc.test \
 test_subst2.h.test test_subst2.cc.test \
-test1.h.test test1_c.h.test example_text.h.test example_text_c.h.test \
+test1.h.test test1_c.h.test test1_lua.lua.test example_text.h.test example_text_c.h.test example_text_lua.lua.test \
 example_fundef.h.test \
-test_cicle_c.h.test \
-test_cicle2_c.h.test \
-test_cicle2_c.c.test \
-test_body_loop_c.h.test \
+test_cicle_c.h.test test_cicle_lua.lua.test \
+test_cicle2_c.h.test test_cicle2_lua.header.test \
+test_cicle2_c.c.test test_cicle2_lua.lua.test \
+test_body_loop_c.h.test test_body_loop_lua.lua.test \
 gen_test_cicle_c.cc.test \
 gen_test_cicle_str_c.cc.test \
 gen_test_cicle_c_cc.cc.test \
 gen_test_cicle_cstring.cc.test \
 test_cicle_tabs.h.test \
 test_cicle_tabs_c.h.test \
+test_cicle_tabs_lua.lua.test \
 gen_test_cicle_tabs.cc.test \
 gen_test_cicle_tabs_c.cc.test \
-test_if.h.test test_if_c.h.test \
-test_types.h.test test_types_c.h.test
+test_if.h.test test_if_c.h.test test_if_lua.lua.test \
+test_types.h.test test_types_c.h.test test_types_lua.lua.test
 
 CXXLD = $(CXX)
 COMPILE_BUILT_EXEC = $(CXXLD) -DHAVE_CONFIG_H $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -I$(top_builddir)/tests/ -I$(top_srcdir)/src/ -I$(top_builddir)/ -o $@ $^
 CCLD = $(CC)
 COMPILE_C_BUILT_EXEC = $(CCLD) $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -I$(top_builddir)/tests/ -o $@ $^
 
-
 test_vars$(EXEEXT): $(test_vars_BUILT_SRC)
 	$(COMPILE_BUILT_EXEC)
 
@@ -251,6 +260,9 @@ example_text.h: example_text.text_skel
 example_text_c.h: example_text.text_skel
 	$(GENERATE) -i $< --file-name $@ --gen-name example_text --output-format=c
 
+example_text_lua.lua: example_text.text_skel
+	$(GENERATE) -i $< --file-name $@ --gen-name example_text --output-format=lua
+
 test_if$(EXEEXT): $(test_if_BUILT_SRC) test_if.h
 	$(COMPILE_BUILT_EXEC)
 
@@ -271,6 +283,10 @@ test_cicle2_c.c: test_cicle2_c.h
 test_cicle2_c.h: test_cicle.cc_skel
 	$(GENERATE_C) -i $< --file-name $@ --gen-name test_cicle --separate-files
 
+test_cicle2_lua.lua: test_cicle2_lua.header
+test_cicle2_lua.header: test_cicle.cc_skel
+	$(GENERATE_LUA) -i $< --file-name $@ --gen-name test_cicle --separate-files
+
 gen_test_vars.cc: test_vars$(EXEEXT)
 	$(top_builddir)/tests/$< > $@
 
@@ -401,6 +417,7 @@ check-valgrind: valgrind_tests.sh
 check-gengen-valgrind: valgrind_gengen_tests.sh
 	$(SHELL) valgrind_gengen_tests.sh $(PROGEXE) -i $(srcdir)/test_cicle_tabs.cc_skel --file-name temp_file --gen-name test_cicle --expand-tabs
 	$(SHELL) valgrind_gengen_tests.sh $(PROGEXE_C) -i $(srcdir)/test_cicle_tabs.cc_skel --file-name temp_file --gen-name test_cicle --expand-tabs
+	$(SHELL) valgrind_gengen_tests.sh $(PROGEXE_LUA) -i $(srcdir)/test_cicle_tabs.cc_skel --file-name temp_file --gen-name test_cicle --expand-tabs
 	rm -f temp_file
 
 CLEANFILES = $(BUILT_SOURCES) $(BUILT_EXECUTABLES) *.err_test $(VERBOSEOUT)
diff --git a/tests/example_text_gen_lua.lua b/tests/example_text_gen_lua.lua
new file mode 100644
index 0000000..3c2f295
--- /dev/null
+++ b/tests/example_text_gen_lua.lua
@@ -0,0 +1,17 @@
+
+require("example_text_lua")
+
+init_example_text_gen_table(example_text_gen_table)
+example_text_gen_table.name = "an example"
+example_text_gen_table.progname = "example_text_gen"
+example_text_gen_table.generator = "Gengen"
+example_text_gen_table.version = "1.0"
+
+generate_example_text(stdout, example_text_gen_table, 0)
+print("\n")
+
+example_text_gen_table.name = "another example"
+io.write("  ")
+
+generate_example_text(stdout, example_text_gen_table, 2)
+io.write("\n")
diff --git a/tests/test1_gen_lua.lua b/tests/test1_gen_lua.lua
new file mode 100644
index 0000000..065500f
--- /dev/null
+++ b/tests/test1_gen_lua.lua
@@ -0,0 +1,9 @@
+
+require ("test1_lua")
+
+test1_gen_table.i = "foo"
+generate_test1(stdout, test1_gen_table, 0)
+print("\n")
+test1_gen_table.i = "bar"
+generate_test1(stdout, test1_gen_table, 0)
+print("\n")
diff --git a/tests/test_body_loop.lua_skel b/tests/test_body_loop.lua_skel
new file mode 100644
index 0000000..4211f39
--- /dev/null
+++ b/tests/test_body_loop.lua_skel
@@ -0,0 +1,7 @@
+cout << "These are the numbers from " << 
+        @my_start@ << " to " << @my_end@ << endl;
+
+for (int i = @my_start@; i <= @my_end@; ++i)
+   cout << i << " ";
+
+cout << endl;
diff --git a/tests/test_cicle2_main.lua b/tests/test_cicle2_main.lua
new file mode 100644
index 0000000..d3c4e99
--- /dev/null
+++ b/tests/test_cicle2_main.lua
@@ -0,0 +1,16 @@
+
+require("test_cicle2_lua.lua")
+require("test_body_loop_lua.lua")
+
+function generate_loop(stream, table, indent)
+  table.my_start = "1"
+  table.my_end = "10"
+  generate_test_body_loop (stream, table, indent)
+end
+
+function generate_return_st(stream, table, indent)
+end
+
+test_cicle_gen_table.loopnum = "10"
+test_cicle_gen_table.return_st = "return 0;"
+generate_test_cicle (stdout, test_cicle_gen_table, 0);
diff --git a/tests/test_cicle_gen_lua.lua b/tests/test_cicle_gen_lua.lua
new file mode 100644
index 0000000..00b2115
--- /dev/null
+++ b/tests/test_cicle_gen_lua.lua
@@ -0,0 +1,16 @@
+
+require("test_cicle_lua.lua")
+require("test_body_loop_lua.lua")
+
+function generate_loop(stream, table, indent)
+  table.my_start = "1"
+  table.my_end = "10"
+  generate_test_body_loop (stream, table, indent)
+end
+
+function generate_return_st(stream, table, indent)
+end
+
+test_cicle_gen_table.loopnum = "10"
+test_cicle_gen_table.return_st = "return 0;"
+generate_test_cicle (stdout, test_cicle_gen_table, 0);
diff --git a/tests/test_cicle_tabs_gen_lua.lua b/tests/test_cicle_tabs_gen_lua.lua
new file mode 100644
index 0000000..fed32da
--- /dev/null
+++ b/tests/test_cicle_tabs_gen_lua.lua
@@ -0,0 +1,17 @@
+--[[
+     rely on the generate_string method that expands tabs for strings
+     in this case, the loop field
+--]]
+
+dofile("test_cicle_tabs_lua.lua")
+dofile("test_body_loop_lua.lua")
+
+test_body_loop_gen_table.my_start = "1"
+test_body_loop_gen_table.my_end = "10"
+loop_str = genstring_test_body_loop(test_body_loop_gen_table, 0)
+
+test_cicle_gen_table.loopnum = "10"
+test_cicle_gen_table.return_st = "return 0;"
+test_cicle_gen_table.loop = loop_str
+
+generate_test_cicle(stdout, test_cicle_gen_table, 0)
diff --git a/tests/test_if_gen_lua.lua b/tests/test_if_gen_lua.lua
new file mode 100644
index 0000000..b224598
--- /dev/null
+++ b/tests/test_if_gen_lua.lua
@@ -0,0 +1,11 @@
+
+require("test_if_lua")
+
+test_if_gen_table.myvar = "\"fooval\""
+test_if_gen_table.mydef = "foodef";
+test_if_gen_table.boolvar = 0;
+test_if_gen_table.intvar = 0;
+test_if_gen_table.intvarcomp = 0;
+test_if_gen_table.stringvar = "bar";
+test_if_gen_table.stringvarcomp = "ba";
+generate_test_if(stdout, test_if_gen_table, 0);
diff --git a/tests/test_types_gen_lua.lua b/tests/test_types_gen_lua.lua
new file mode 100644
index 0000000..a939f52
--- /dev/null
+++ b/tests/test_types_gen_lua.lua
@@ -0,0 +1,7 @@
+
+require("test_types_lua")
+
+test_types_gen_table.mystring = "hello_world"
+test_types_gen_table.myint = 1971
+test_types_gen_table.mybool = 1
+generate_test_types(stdout, test_types_gen_table, 0)
